﻿namespace Tests
{
    class Test1
    {
        class Class1
        {
            public void method(Class2 c2)
            {
                lock (this)
                {
                    c2.method(this);
                }
            }
        }

        class Class2
        {
            public void method(Class1 c1)
            {
                lock (this)
                {
                    c1.method(this);
                }
            }
        }

        class Class3
        {
            object monitor1 = new object();
            object monitor2 = new object();

            public void method1()
            {
                lock (monitor1)
                {
                    lock (monitor2)
                    {
                    }
                }
            }

            public void method2()
            {
                lock (monitor2)
                {
                    lock (monitor1)
                    {
                    }
                }
            }
        }

        class Class4
        {
            public object monitor = new object();

            public void method(Class5 c5)
            {
                lock (monitor)
                {
                    c5.method1();
                }
            }
        }

        class Class5
        {
            object monitor = new object();

            public void method1()
            {
                lock (monitor)
                {
                }
            }

            public void method2(Class4 c4)
            {
                lock (monitor)
                {
                    lock (c4.monitor)
                    {
                    }
                }
            }
        }
    }
}
